/***************************************************************************
                          kbeartextedit.h  -  description
                             -------------------
    begin                : Fri Apr 12 2002
    copyright            : (C) 2002 by Peter Svrd
    email                : tocool@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KBEARTEXTEDIT_H
#define KBEARTEXTEDIT_H

//////////////////////////////////////////////////////
// Qt specific includes
#include <qtextedit.h>
#include <qpopupmenu.h>
//////////////////////////////////////////////////////
// KDE specific includes

//////////////////////////////////////////////////////
// Application specific includes

//////////////////////////////////////////////////////

/**
* @author Peter Swrd
*/

class KBearTextEdit : public QTextEdit
{
	Q_OBJECT
	public:
 		KBearTextEdit(QWidget* parent=0, const char* name=0);
    virtual ~KBearTextEdit();

  public slots:
  	/** No descriptions */
  	void slotSaveAs();
	protected:
		/** Reimplemented from QTextEdit, just to be able to add some extra functions to the popupmenu. */
		virtual QPopupMenu* createPopupMenu(const QPoint & pos);
  private:
		/** No descriptions */
  	QPopupMenu* popUp;
};

#endif
